class MapParticule {

  public final PVector gravity = new PVector( 0,0,-0.01 );
  public static final float MT_SPEED = 2;
  public static final float MT_DEVIATION = 0.03f;

  PVector direction;
  float[] positions;

  public MapParticule( float x, float y, float z ) {
    
    positions = new float[ 4 ];
    reset( x,y,z );
    
  }
  
  public void reset( float x, float y, float z ) {
    
    positions[ 0 ] = x;
    positions[ 1 ] = y;
    positions[ 2 ] = z;
    positions[ 3 ] = 0; // slope, pente en anglais

    direction = new PVector();
    direction.x = random( -1, 1 );
    direction.y = random( -1, 1 );
    direction.z = 0;
    direction.normalize();
    
  }

  public void update( MapMesh mesh ) {
    
    direction.add( gravity );

    positions[ 0 ] += direction.x * MT_SPEED;
    positions[ 1 ] += direction.y * MT_SPEED;
    positions[ 2 ] += direction.z * MT_SPEED;
    if ( positions[ 0 ] < 0 )
      positions[ 0 ] = 0;
    if ( positions[ 0 ] >= mesh.width )
      positions[ 0 ] = mesh.width-1;
    if ( positions[ 1 ] < 0 )
      positions[ 1 ] = 0;
    if ( positions[ 1 ] >= mesh.height )
      positions[ 1 ] = mesh.height-1;

    float[] proj = mesh.getDepth( positions[ 0 ], positions[ 1 ], direction.x, direction.y );
    if ( positions[ 2 ] < proj[ 0 ] ) {
      positions[ 2 ] = proj[ 0 ];
      positions[ 3 ] = proj[ 1 ];
      direction.x += proj[ 2 ] * 0.2f;
      direction.y += proj[ 3 ] * 0.2f;
    } else {
      positions[ 3 ] = 0;
    }

    if ( positions[ 0 ] + direction.x < 0 || positions[ 0 ] + direction.x * MT_SPEED > mesh.width )
      direction.x *= -1;
    if ( positions[ 1 ] + direction.y < 0 || positions[ 1 ] + direction.y * MT_SPEED > mesh.height )
      direction.y *= -1;

    direction.x += random( -MT_DEVIATION, MT_DEVIATION );
    direction.y += random( -MT_DEVIATION, MT_DEVIATION );
    direction.normalize();
  }
}

